Index: /trunk/prototype/modules/calendar/js/helpers.js
===================================================================
--- /trunk/prototype/modules/calendar/js/helpers.js	(revision 5641)
+++ /trunk/prototype/modules/calendar/js/helpers.js	(revision 5715)
@@ -361,5 +361,161 @@
 			
 		}
-		
+
+	    DataLayer.render( 'templates/event_repeat.ejs', {event:objEvent}, function( repeatHtml ){
+
+			UI.dialogs.addEvent.find('#calendar_addevent_details3').html(repeatHtml);
+			$(".date").datepicker();
+		  
+			if(objEvent.repeat) 
+			{
+			     if( objEvent.repeat['id'] )
+			     {
+				$("[name='repeatId']:last").val( objEvent.repeat['id'] );
+			     }
+
+			     if( objEvent.repeat['frequency'] !== 'none' )
+			     {
+				if( objEvent.repeat['startTime'] && objEvent.repeat['startTime'] !== "0" )
+				{
+				      $("[name='startOptions'] [value='customDate']:last").attr( 'selected', 'selected' );
+				      $("[name='start']:last").val(new Date( parseInt(objEvent.repeat['startTime']) ).toString( User.preferences.dateFormat ) );
+				}
+				else
+				{
+				      $("[name='start']:last").val($("[name='startDate']:last").val());     
+				      $("[name='start']:last").readOnly=true;
+				      $("[name='start']:last").datepicker("disable");
+				}
+			      
+				$(".finish_event").removeClass("hidden");
+
+				if(objEvent.repeat['endTime'] && objEvent.repeat['endTime'] !== "0" ) 
+				{
+					//$("[name='occurrences']").addClass("hidden");
+					$(".customDateEnd").removeClass("hidden");
+							$(".endRepeat option[value='customDate']").attr('selected', 'selected')						
+					$(".customDateEnd").val( new Date( parseInt(objEvent.repeat['endTime']) )/*.setTimezoneOffset( Timezone.timezone( objEvent.timezone ) )*/.toString( User.preferences.dateFormat ) );  
+				}
+				else if (objEvent.repeat['count'] && objEvent.repeat['count'] !== "0" ) {
+					$(".endRepeat option[value='occurrences']").attr('selected', 'selected');						
+					$(".occurrencesEnd").removeClass("hidden");
+					$(".occurrencesEnd").val(objEvent.repeat['count']);						
+				}
+			      
+				switch ( objEvent.repeat['frequency'] )
+				{
+				    case "daily":
+					    $(".event-repeat-container:last").find(".repeat-in").find(".interval").html("Dia(s)");
+					    $(".frequency option[value='daily']").attr('selected', 'selected');
+					    break;
+				    case "weekly":
+					    $(".event-repeat-container:last").find(".repeat-in").find(".interval").html("Semana(s)");
+					    $(".frequency option[value='weekly']").attr('selected', 'selected');
+					    objEvent.repeat['interval'] ? $(".event-repeat-container:last").find(".repeat-in").find(".eventInterval").val(objEvent.repeat['interval']) : $(".event-repeat-container:last").find(".repeat-in").find(".eventInterval").val("0");
+					    
+					    $(".event-repeat-weekly").removeClass("hidden");
+					    
+					    var day = [];
+					    
+					    if( objEvent.repeat.byday )
+						day = objEvent.repeat.byday.split(',');
+					    
+					    for(i=0; i<day.length; i++) 
+						    $(".event-repeat-weekly [value='" + day[i] + "']").attr("checked","checked");
+					    
+					    break;
+				    case "monthly":
+					    $(".event-repeat-container:last").find(".repeat-in").find(".interval").html("Mes(s)");
+					    $(".frequency option[value='monthly']").attr('selected', 'selected')
+					    $(".event-repeat-monthly:last").removeClass("hidden").find("input[type=radio][name=repeatmonthyType]").click(function(){
+						    if($("input[type=radio][name=repeatmonthyType]:checked").val() == "1")
+							    $(".event-repeat-weekly:last").removeClass("hidden");
+						    else
+							    $(".event-repeat-weekly:last").addClass("hidden");
+					    });
+					    if($("input[type=radio][name=repeatmonthyType]:checked").val() == "1")
+						    $(".event-repeat-weekly:last").removeClass("hidden");
+					    else
+						    $(".event-repeat-weekly:last").addClass("hidden");
+					    break;
+				    case "yearly":
+					    $(".event-repeat-container:last").find(".repeat-in").find(".interval").html("Ano(s)");
+					    $(".frequency option[value='yearly']").attr('selected', 'selected')
+					    break;	
+				}
+			    }
+			}
+			else {
+				$(".endRepeat option[value='never']").attr('selected', 'selected');
+			}
+
+
+			$(".event-repeat-container:last").find(".repeat-in").find("[name=startOptions]").change(function(){                                       
+
+            if($(this).find("option:selected").val() == "Today"){
+                                $("[name='start']:last").val($("[name='startDate']:last").val());
+                                $("[name='start']:last").readOnly=true;
+                                $("[name='start']:last").datepicker("disable");
+                            }
+                            else{
+                                $("[name='start']:last").readOnly=false;
+                                $("[name='start']:last").datepicker("enable");
+                            }
+                        });
+                        $(".event-repeat-container:last").find(".repeat-in").find("[name=endOptions]").change(function(){                                       
+                            if($(this).find("option:selected").val() == "never"){
+                                $("[name='occurrences']").addClass("hidden");
+                                $("[name='end']:last").addClass("hidden");
+                            }
+                            else if($(this).find("option:selected").val() == "customDate"){
+                                $("[name='occurrences']").addClass("hidden");
+                                $("[name='end']:last").removeClass("hidden");    
+                            }
+                            else{
+                                $("[name='end']:last").addClass("hidden");
+                                $("[name='occurrences']").removeClass("hidden");                                        
+                            }
+                        });
+                        
+			$("[name='frequency']:last").change(function () {
+				$(".frequency-option").addClass("hidden");
+                                if($(this).val() == "none"){
+					$(".repeat-in").addClass("hidden");
+					return;
+				}else{
+                                    $(".repeat-in").removeClass("hidden");
+                                    $("[name='start']:last").val($("[name='startDate']:last").val());
+                                }
+                 
+				 
+				switch($(this).val()){
+                    case "daily":
+                        $(".event-repeat-container:last").find(".repeat-in").find(".interval").html("Dia(s)");
+                        break;
+					case "weekly":
+                        $(".event-repeat-container:last").find(".repeat-in").find(".interval").html("Semana(s)");
+						$(".event-repeat-weekly:last").removeClass("hidden");
+						break;
+					case "monthly":
+                        $(".event-repeat-container:last").find(".repeat-in").find(".interval").html("Mes(s)");
+						$(".event-repeat-monthly:last").removeClass("hidden").find("input[type=radio][name=repeatmonthyType]").click(function(){
+							if($("input[type=radio][name=repeatmonthyType]:checked").val() == "1")
+								$(".event-repeat-weekly:last").removeClass("hidden");
+							else
+								$(".event-repeat-weekly:last").addClass("hidden");
+						});
+                        if($("input[type=radio][name=repeatmonthyType]:checked").val() == "1")
+                            $(".event-repeat-weekly:last").removeClass("hidden");
+						else
+                            $(".event-repeat-weekly:last").addClass("hidden");
+					    break;
+                    default:
+                        $(".event-repeat-container:last").find(".repeat-in").find(".interval").html("Ano(s)");
+                        break;
+				}
+				
+			});
+		});
+
 	    UI.dialogs.addEvent.find('.calendar_addevent_details_lnk_timezone').click(function(e){
 		    $(this).addClass('hidden');
@@ -627,5 +783,5 @@
 					var user = DataLayer.get('user', ["=", "mail", $(this).val()]);
 					if(!!user && user[0].id)
-						attendees[user[0].id].name  = user[0].name;
+						attendees[user[0].id] = { name: user[0].name };
 					
 					/**
Index: /trunk/prototype/api/datalayer.js
===================================================================
--- /trunk/prototype/api/datalayer.js	(revision 5615)
+++ /trunk/prototype/api/datalayer.js	(revision 5715)
@@ -136,4 +136,5 @@
     nestedLinks: {},
     concepts: {},
+    notArray: {},
     listeners: {},
     encoders: {},
@@ -388,10 +389,10 @@
 		    if( data[i][link] )
 		    {
-			var isConcept = false;
-		      
-			if( isConcept = this.isConcept( concept, link ) )
+			var notArray2 = false;
+
+			if( notArray2 = this.hasOne( concept, link ) )
 			    data[i][link] = [ data[i][link] ];
 
-			var _this = this;
+			var _this = this, dependency = this.isDependency( concept, link );
 
 			$.each( data[i][link], function( ii, el ){
@@ -404,5 +405,5 @@
 				//removido pois o mesmo esta gerando inconsistencia em tudo
 // 				if( DataLayer.isConcept( links[link], nestedLinks[link] ) )
-				if( isConcept )
+				if( !DataLayer.hasOne( links[link], nestedLinks[link] ) )
 				{
 				    el[ nestedLinks[link] ] = el[ nestedLinks[link] ] || [];
@@ -413,5 +414,5 @@
 
 				if( isRef && ( !current[ key ] || !current[ key ][ link ] || 
-				               (isConcept ? current[ key ][ link ] !== el.id : !$.inArray( el.id, current[ key ][ link ] )) ) )
+				               (notArray2 ? current[ key ][ link ] !== el.id : !$.inArray( el.id, current[ key ][ link ] )) ) )
 				{
 				    updateSet[ links[link] ] = updateSet[ links[link] ] || [];
@@ -422,5 +423,5 @@
 			    });
 
-			if( isConcept )
+			if( notArray2 )
 			    data[i][link] = data[i][link][0];
 		    }
@@ -489,5 +490,5 @@
 		    continue;
 
-		if( isConcept = this.isConcept( concept, link ) )
+		if( this.hasOne( concept, link ) )
 		    current[i][link] = [ current[i][link] ];
 
@@ -972,4 +973,6 @@
 
 	    this.links[ concept ] =  result['links'] || {};
+	    
+	    this.notArray[ concept ] = result['hasOne'] || {};
 
 	   this.nestedLinks[ concept ] = result['nestedLinks'] || {};
@@ -985,5 +988,5 @@
     },
     
-    isConcept: function( concept, attr ){
+    isDependency: function( concept, attr ){
       
 	if( typeof this.concepts[concept] === "undefined" )
@@ -993,4 +996,14 @@
 
 	return !!this.concepts[ concept ][ attr ];
+    },
+    
+    hasOne: function( concept, attr ){
+      
+	if( typeof this.notArray[concept] === "undefined" )
+	{
+	    this.links( concept );
+	}
+
+	return !!this.notArray[ concept ][ attr ];
     },
     
@@ -1112,5 +1125,5 @@
       
 	for( var key in base )
-	    if( this.storage.filter( base[key], this.copy( filter ) ) )
+	    if( this.storage.filter( base[key], filter ) )
 		filtered[ filtered.length ] = key;
 
@@ -1125,8 +1138,8 @@
 
     
-    compare: function( operator, b, t ){
+    compare: function( operator, base, test ){
       
-	var base = this.converterType(b);
-	var test = this.converterType(t);
+	base = this.converterType(base);
+	test = this.converterType(test);
 	 
     switch( operator ){
@@ -1145,5 +1158,5 @@
 	case '<':  return ( base >  test );
 	
-	default: return false;
+	default: return true;
 	}
       
@@ -1164,12 +1177,12 @@
 
 	if( !filter || !result )
-	  return DataLayer.copy( result || false );
-
-	var keys = [];
-
-	if( notArray = $.type(filter) === "string" )
-	    keys = [ filter ];
-	else if( $.type(filter) !== "array" )
-		keys = this.filter( result, filter.filter, filter.criteria );
+	  return( result || false );
+
+	var keys = DataLayer.copy( filter );
+
+	if( notArray = $.type(keys) === "string" )
+	    keys = [ keys ];
+	else if( $.type(keys) !== "array" )
+		keys = this.filter( result, keys.filter, keys.criteria );
 
 	var res = [];
@@ -1178,5 +1191,5 @@
 	    res[ res.length ] = result[keys[i]];
 
-	return DataLayer.copy( notArray ? res[0] || false : res.length ? res : false );
+	return( notArray ? res[0] || false : res.length ? res : false );
     },
 
@@ -1192,5 +1205,5 @@
 	get: function( key ){
 
-	    return this.cache[key];
+	    return DataLayer.copy( this.cache[key] );
 
 	},
